// Copyright © Microsoft Corporation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.opengroup.osdu.notification.provider.azure.util;

import lombok.Getter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
@Getter
public class AzureServiceBusConfig {
    @Value("${executor-n-threads}")
    private String nThreads;

    @Value("${max-concurrent-calls}")
    private String maxConcurrentCalls;

    @Value("${max-lock-renew}")
    private String maxLockRenewDurationInSeconds;

    @Value("${initial-subscription-manager-delay}")
    private String initialSubscriptionManagerDelay;

    @Value("${consecutive-subscription-manager-delay}")
    private String consecutiveSubscriptionManagerDelay;

    @Value("${service-bus-enabled}")
    private String ServiceBusEnabled;

    @Value("${event-grid-to-service-bus-enabled}")
    private String EventGridToServiceBusEnabled;

    @Bean
    public MDCContextMap mdcContextMap() {
        return new MDCContextMap();
    }

}
