// Copyright © Microsoft Corporation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.opengroup.osdu.notification.util;

import org.junit.Test;
import org.junit.jupiter.api.Assertions;
import org.opengroup.osdu.notification.provider.azure.util.GoogleServiceAccountImpl;
import sun.reflect.generics.reflectiveObjects.NotImplementedException;

import static org.junit.Assert.fail;

public class GoogleServiceAccountImpTest {

    @Test
    public void should_throw_getIdToken() {
        // Setup
        String audience = "testAudience";
        String keyString = "keyString";

        try {
            // Act
            new GoogleServiceAccountImpl().getIdToken(keyString, audience);

            // Assert
            fail("Should throw exception");
        } catch (Exception e) {
            Assertions.assertEquals(e.getClass(), NotImplementedException.class);
        }
    }
}
