/*
 *   Copyright 2017-2020, Schlumberger
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

package org.opengroup.osdu.notification.provider.gcp.util;

import org.opengroup.osdu.notification.provider.interfaces.IAppProperties;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class AppProperties implements IAppProperties {

    @Value("${app.entitlements}")
    private String authorizeAPI;
    @Value("${app.register}")
    private String registerAPI;
    @Value("${app.project}")
    private String projectId;
    @Value("${app.googleAudience}")
    private String googleAudience;
    @Value("${app.expireTime}")
    private int expireTime;
    @Value("${app.maxCacheSize}")
    private int maxCacheSize;


    public String getAuthorizeAPI() {
        return authorizeAPI;
    }

    public String getRegisterAPI() {
        return registerAPI;
    }

    public String getPubSubServiceAccountEmail() {
        return String.format("de-notification-service@%s.iam.gserviceaccount.com", this.projectId);
    }

    public String getGoogleAudiences() {
        return this.googleAudience;
    }
}
